# Mobile Proxies

GoProxies Mobile Proxies provide high-anonymity mobile IPs that originate from real cellular networks. You can successfully avoid rate limits and geo-restrictions while staying completely anonymous. These IPs behave like real mobile device connections, making them ideal for app testing, ad verification, mobile emulation, and geo-sensitive data collection.&#x20;

**Key benefits:**

* Authentic 4G/5G mobile IPs
* Fast response times
* High success rate
* Precise geo-targeting by country, state, city or ASN
* Dynamic IP rotation and sticky sessions

### Endpoints and Protocols

Service is accessed using following entry data:

* **Host:** proxy.goproxies.com - All countries.&#x20;

{% hint style="info" %}
Although we have an automatic routing, you may manually target preferred regions to reduce latency:&#x20;

* proxy-asia.goproxies.com - for Asia and Oceania

* proxy-europe.goproxies.com - for Europe and Africa

* proxy-america.goproxies.com - for both Americas
  {% endhint %}

* **Port:** 1080

* **Authorisation:** Basic

* **Username/Password:** *\[provided separately].*&#x20;

There are two types of credentials:

1. **Dashboard user** - used to access the [GoProxies dashboard](https://dashboard.goproxies.com/).
2. **Proxy user** - used to access our proxy pool. Please ensure you use the proxy user credentials when sending requests to our proxy network.

Example test:

{% tabs %}
{% tab title="cURL" %}
{% code overflow="wrap" %}

```bash
curl --proxytunnel --proxy "https://customer-USERNAME:PASSWORD@proxy.goproxies.com:1080" https://ip.goproxies.com
```

{% endcode %}
{% endtab %}

{% tab title="JavaScript" %}

```bash
npm install axios https-proxy-agent
```

```javascript
// example.js
const axios = require('axios');
const { HttpsProxyAgent } = require('https-proxy-agent');

const proxyAuth = encodeURIComponent('customer-USERNAME') + ':' + encodeURIComponent('PASSWORD');
const proxyUrl = `http://${proxyAuth}@proxy.goproxies.com:1080`; // use http:// here for CONNECT proxy auth
const agent = new HttpsProxyAgent(proxyUrl);

(async () => {
  try {
    const res = await axios.get('https://ip.goproxies.com', { httpsAgent: agent, timeout: 10000 });
    console.log('status:', res.status);
    console.log('body:', res.data);
  } catch (err) {
    console.error('request error:', err.message);
  }
})();
```

{% endtab %}

{% tab title="Python" %}

```python
import requests

username = "customer-USERNAME"
password = "PASSWORD"

proxy = f"https://{username}:{password}@proxy.goproxies.com:1080"

proxies = {
    "http": proxy,
    "https": proxy,
}

resp = requests.get("https://ip.goproxies.com", proxies=proxies, timeout=10)

print(resp.status_code)
print(resp.text)
```

{% endtab %}

{% tab title="Go" %}

```go
package main

import (
	"fmt"
	"net/http"
	"net/url"
	"time"
	"io"
)

func main() {
	proxyURL, _ := url.Parse("http://customer-USERNAME:PASSWORD@proxy.goproxies.com:1080")
	transport := &http.Transport{
		Proxy: http.ProxyURL(proxyURL),
		// Optional: tune TLSHandshakeTimeout, IdleConnTimeout, etc.
		TLSHandshakeTimeout: 10 * time.Second,
	}
	client := &http.Client{Transport: transport, Timeout: 15 * time.Second}

	resp, err := client.Get("https://ip.goproxies.com")
	if err != nil {
		fmt.Println("request error:", err)
		return
	}
	defer resp.Body.Close()
	body, _ := io.ReadAll(resp.Body)
	fmt.Println("status:", resp.Status)
	fmt.Println(string(body))
}

```

{% endtab %}

{% tab title="Java" %}

```java
import org.apache.http.HttpHost;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.impl.client.BasicCredentialsProvider;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;

public class ProxyExample {
  public static void main(String[] args) throws Exception {
    String proxyHost = "proxy.goproxies.com";
    int proxyPort = 1080;
    String user = "customer-USERNAME";
    String pass = "PASSWORD";

    CredentialsProvider credsProvider = new BasicCredentialsProvider();
    credsProvider.setCredentials(new AuthScope(proxyHost, proxyPort), new UsernamePasswordCredentials(user, pass));

    HttpHost proxy = new HttpHost(proxyHost, proxyPort);
    RequestConfig config = RequestConfig.custom().setProxy(proxy).build();

    try (CloseableHttpClient httpclient = HttpClients.custom()
             .setDefaultCredentialsProvider(credsProvider)
             .build()) {
      HttpGet httpget = new HttpGet("https://ip.goproxies.com");
      httpget.setConfig(config);

      try (CloseableHttpResponse response = httpclient.execute(httpget)) {
        System.out.println(response.getStatusLine());
        System.out.println(new String(response.getEntity().getContent().readAllBytes()));
      }
    }
  }
}
```

{% endtab %}

{% tab title="Ruby Net::HTTP" %}

```ruby
require 'net/http'
require 'uri'

username = 'customer-USERNAME'
password = 'PASSWORD'

uri = URI('https://ip.goproxies.com')
proxy_addr = 'proxy.goproxies.com'
proxy_port = 1080

Net::HTTP::Proxy(proxy_addr, proxy_port, username, password).start(uri.host, uri.port, use_ssl: true) do |http|
  req = Net::HTTP::Get.new(uri)
  res = http.request(req)
  puts res.code
  puts res.body
end
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php
$ch = curl_init('https://ip.goproxies.com');

curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_PROXY, 'proxy.goproxies.com:1080');
curl_setopt($ch, CURLOPT_PROXYUSERPWD, 'customer-USERNAME:PASSWORD');
// Use tunnel for HTTPS so CONNECT is used
curl_setopt($ch, CURLOPT_HTTPPROXYTUNNEL, true);

$response = curl_exec($ch);
if ($response === false) {
    echo 'cURL error: ' . curl_error($ch) . PHP_EOL;
} else {
    echo 'Response: ' . $response . PHP_EOL;
}
curl_close($ch);
```

{% endtab %}
{% endtabs %}

#### Control Your Connection <a href="#control-your-connection" id="control-your-connection"></a>

* You can refine your proxy request by including parameters that manage IP selection.&#x20;
* Continue reading our step-by-step guide for more information on additional proxy parameters, along with detailed examples.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.goproxies.com/proxies/mobile-proxies.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
